#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 2e5 + 1;

vector<vector<int>> g;
vector<vector<int>> curg;
vector<int> vec;
int maxim = -1;
int minim = 1e18;
vector<int> dist(N, 1e18);

void dej(int s) {
    set<pair<int, int>> q;
    q.insert({0, s});
    dist[s] = 0;
    while (!q.empty()) {
        int v = q.begin() -> second;
        q.erase(q.begin());
        for (auto u : g[v]) {
            if (dist[u] > dist[v] + 1) {
                q.insert({dist[v] + 1, u});
                dist[u] = dist[v] + 1;
            }
        }
    }
}

int k;

void f(int root, int cur) {
    g[root].push_back(cur);
    g[cur].push_back(root);
    dej(root);
    for (int i = 0; i < g.size(); i++) {
        maxim = max(maxim, dist[i]);
    }
    minim = min(minim, maxim);
    maxim = -1;
}

void fix(int v, int p = -1) {
    for (auto &u : g[v]) {
        if (u == p) {
            u = v;
        } else {
            fix(u, v);
        }
    }
}

int path = -1;
vector<int> parent(N);
int needv;

void maxpath(int v, int p = -1, int deep = 0) {
    for (auto u : g[v]) {
        if (u != p) {
            maxpath(u, v, deep + 1);
        }
    }
    parent[v] = p;
    path = max(deep, path);
    if (path == deep) {
        needv = v;
    }
}

void solve() {
    int n, t;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    maxpath(0);
    parent[0] = 0;
    int polp = path / 2 - (path % 2 == 0);
    while (polp--) {
        needv = parent[needv];
    }
    for (int i = 0; i < n; i++) {
        fix(0, -1);
        f(0, needv);
//        cout << needv + 1 << ' ';
        cout << minim << ' ';
        minim = 1e18;
        if (!t) {
            break;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();
    }
}
