#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 1e5 + 1;

vector<vector<int>> g(N);
vector<int> ans(N, -1), tour;
map<int, int> mapa;

void dfs(int v, int p = -1) {
    if (v == 0) return;
    if (ans[v] == -1) {
        tour.push_back(v);
        mapa[v] = tour.size();
        dfs(g[v][0], v);
        dfs(g[v][1], v);
    } else if (ans[v] == 0) {
        dfs(g[v][0], v);
        tour.push_back(v);
        mapa[v] = tour.size();
        dfs(g[v][1], v);
    } else {
        dfs(g[v][0], v);
        dfs(g[v][1], v);
        tour.push_back(v);
        mapa[v] = tour.size();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        g[i + 1].push_back(l);
        g[i + 1].push_back(r);
    }
    int cnt = 0;
    int last = -1;
    while (q--) {
        cnt++;
        int type;
        cin >> type;
        if (type == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            for (int i = l; i <= r; i++) {
                ans[i] = x;
            }
            last = cnt;
        } else {
            if (last == cnt - 1) {
                tour.clear();
                dfs(1);
            }
            int i;
            cin >> i;
            cout << mapa[i] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();
    }
}
