#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 2e5 + 1;

vector<vector<int>> g;
vector<vector<int>> curg;
vector<int> vec;
int maxim = -1;
int minim = 1e18;
vector<int> dist(N);

void dej(int s) {
    set<pair<int, int>> q;
    q.insert({0, s});
    dist[s] = 0;
    while (!q.empty()) {
        int v = q.begin() -> second;
        q.erase(q.begin());
        for (auto u : curg[v]) {
            if (dist[u] > dist[v] + 1) {
                q.insert({dist[v] + 1, u});
                dist[u] = dist[v] + 1;
            }
        }
    }
}

int k;

void f(int j, int root, vector<int> cur, int last) {
    if (last != -1) {
        cur.push_back(last);
    }
    if (cur.size() == k) {
        curg = g;
        for (auto i : cur) {
            curg[root].push_back(i);
            curg[i].push_back(root);
//            cout << i << '\n';
        }
//        cout << '\n';
        fill(dist.begin(), dist.begin() + g.size(), 1e18);
        dej(root);
        for (int i = 0; i < g.size(); i++) {
            maxim = max(maxim, dist[i]);
//            if (cur[0] == 3) {
//                cout << dist[i] << ' ';
//            }
        }
        minim = min(minim, maxim);
        maxim = -1;
        return;
    }
    for (int i = j; i < g.size(); i++) {
        if (i == root) continue;
        f(i + 1, root, cur, i);
    }
}

void fix(int v, int p = -1) {
    for (auto &u : g[v]) {
        if (u == p) {
            u = v;
        } else {
            fix(u, v);
        }
    }
}

void solve() {
    int n, t;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < n; i++) {
        fix(0, -1);
        f(0, i, vec, -1);
        cout << minim << ' ';
        minim = 1e18;
        if (!t) {
            break;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();
    }
}
