#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> solve(int n, vector<int> vec) {
    vector<int> arr = vec;
    sort(vec.begin(), vec.end());
    map<int, int> col;
    col[1] = 1;
    for (int i = 0; i < n; i++) {
        if (col[vec[i]] != 0) continue;
        int N = vec[i];
        vector<int> prime;
        int f = 2;
        for (int j = 2; j * j <= vec[i]; j++) {
            if (N % j == 0) {
                prime.push_back(vec[i] / j);
                if (col[vec[i] / j] == 2) f = 1;
                while (N % j == 0) {
                    N /= j;
                }
            }
        }
        if (N != 1) {
            prime.push_back(N);
            if (col[vec[i] / N] == 2) {
                f = 1;
            }
        }
        for (auto j : prime) {
            if (f == 2) {
                col[vec[i]] = 2;
                col[j] = 1;
            } else {
                col[vec[i]] = 1;
                col[j] = 2;
            }
        }
//        for (int i = 0; i < n; i++) {
//            cout << col[arr[i]] << ' ';
//        } cout << '\n';
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        ans.push_back(col[arr[i]]);
    }
    return ans;
}

bool isprime(int n) {
    for (int i = 2; i * i <= n; i++) if (n % i == 0) return false;
    return true;
}

void stress() {
    int n = rand() % 100;
    vector<int> vec(n);
    for (auto &i : vec) i = rand();
    auto col = solve(n, vec);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (j % i == 0 && col[i] == col[j]) {
                if (isprime(j / i)) {
                    for (auto v : vec) {
                        cout << v << ' ';
                    }
                    return;
                }
            }
        }
    }
}

signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    int z = 1;
//    cin >> z;
    while (z--) {
        stress();
    }
}
