#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> pw;

void precalc() {
    pw.push_back(1);
    while(pw.size() < 32) {
        pw.push_back(pw.back() * 2);
    }
}

const int N = 1e5 + 1;

int n, m;
vector<int> a, t;

int f (int mid) {
    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (mid < a[i]) continue;
        if (mid < a[i] + t[i]) {
            cur += 1;
            continue;
        }
        if (mid - (a[i] + t[i]) + 1 >= 32) {
            return m + 1;
        }
        cur += pw[mid - (a[i] + t[i]) + 1];
    }
    return cur;
}

void solve() {
    precalc();
    cin >> n >> m;
    a.resize(n);
    t.resize(n);
    for (auto &i : a) {
        cin >> i;
    }
    for (auto &i : t) {
        cin >> i;
    }
    int l = 0, r = 3e9;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (f(mid) <= m) {
            l = mid;
        } else {
            r = mid;
        }
//        cout << mid << ' ' << f(mid) << '\n';
    }
    if (f(l) == m || f(r) == m) {
        cout << l << '\n';
        return;
    }
    cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();
    }
}
